/* Generated from Extensions for telepathy-sofiasip



 */

#ifdef __cplusplus
extern "C" {
#endif

/**
 *
SIPChannelCallStateFlags:
 * @SIP_CHANNEL_CALL_STATE_RINGING: <![CDATA[           The contact has been alerted about the call but has not responded           (e.g. 180 Ringing in SIP).         ]]>
 * @SIP_CHANNEL_CALL_STATE_QUEUED: <![CDATA[           The contact is temporarily unavailable, and the call has been placed           in a queue (e.g. 182 Queued in SIP, or call-waiting in telephony).         ]]>
 *
 * <![CDATA[         A set of flags representing call states.       ]]>
 *
 * Bitfield/set of flags generated from the Telepathy specification.
 */
typedef enum {
    SIP_CHANNEL_CALL_STATE_RINGING = 1,
    SIP_CHANNEL_CALL_STATE_QUEUED = 2,
} SIPChannelCallStateFlags;

/**
 *
SIPChannelHoldState:
 * @SIP_CHANNEL_HOLD_STATE_NONE: <![CDATA[           Neither the local user nor a remote member have placed the call on           hold.         ]]>
 * @SIP_CHANNEL_HOLD_STATE_LOCAL: <![CDATA[           The local user has put the call on hold.         ]]>
 * @SIP_CHANNEL_HOLD_STATE_REMOTE: <![CDATA[           The call has been put on hold by a remote member.         ]]>
 * @SIP_CHANNEL_HOLD_STATE_BOTH: <![CDATA[           The local user and a remote member have both placed the call           on hold.         ]]>
 *
 * <![CDATA[         The possible hold states of a call.       ]]>
 *
 * Bitfield/set of flags generated from the Telepathy specification.
 */
typedef enum {
    SIP_CHANNEL_HOLD_STATE_NONE = 0,
    SIP_CHANNEL_HOLD_STATE_LOCAL = 1,
    SIP_CHANNEL_HOLD_STATE_REMOTE = 2,
    SIP_CHANNEL_HOLD_STATE_BOTH = 3,
} SIPChannelHoldState;

/**
 * NUM_SIP_CHANNEL_HOLD_STATES:
 *
 * 1 higher than the highest valid value of #SIPChannelHoldState.
 */
#define NUM_SIP_CHANNEL_HOLD_STATES (3+1)


#ifdef __cplusplus
}
#endif
