#include "_gen/svc-channel.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _sip_svc_channel_interface_call_state_object_info;

struct _SIPSvcChannelInterfaceCallStateClass {
    GTypeInterface parent_class;
    sip_svc_channel_interface_call_state_get_call_states_impl get_call_states;
};

enum {
    SIGNAL_CHANNEL_INTERFACE_CALL_STATE_CallStateChanged,
    N_CHANNEL_INTERFACE_CALL_STATE_SIGNALS
};
static guint channel_interface_call_state_signals[N_CHANNEL_INTERFACE_CALL_STATE_SIGNALS] = {0};

static void sip_svc_channel_interface_call_state_base_init (gpointer klass);

GType
sip_svc_channel_interface_call_state_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SIPSvcChannelInterfaceCallStateClass),
        sip_svc_channel_interface_call_state_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SIPSvcChannelInterfaceCallState", &info, 0);
    }

  return type;
}

/**
 * sip_svc_channel_interface_call_state_get_call_states_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetCallStates on interface org.freedesktop.Telepathy.Channel.Interface.CallState.
 */
static void
sip_svc_channel_interface_call_state_get_call_states (SIPSvcChannelInterfaceCallState *self,
    DBusGMethodInvocation *context)
{
  sip_svc_channel_interface_call_state_get_call_states_impl impl = (SIP_SVC_CHANNEL_INTERFACE_CALL_STATE_GET_CLASS (self)->get_call_states);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * sip_svc_channel_interface_call_state_implement_get_call_states:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetCallStates D-Bus method
 *
 * Register an implementation for the GetCallStates method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
sip_svc_channel_interface_call_state_implement_get_call_states (SIPSvcChannelInterfaceCallStateClass *klass, sip_svc_channel_interface_call_state_get_call_states_impl impl)
{
  klass->get_call_states = impl;
}

/**
 * sip_svc_channel_interface_call_state_emit_call_state_changed:
 * @instance: The object implementing this interface
 * @arg_contact: guint  (FIXME, generate documentation)
 * @arg_state: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * CallStateChanged signal on interface org.freedesktop.Telepathy.Channel.Interface.CallState.
 */
void
sip_svc_channel_interface_call_state_emit_call_state_changed (gpointer instance,
    guint arg_contact,
    guint arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SIP_TYPE_SVC_CHANNEL_INTERFACE_CALL_STATE));
  g_signal_emit (instance,
      channel_interface_call_state_signals[SIGNAL_CHANNEL_INTERFACE_CALL_STATE_CallStateChanged],
      0,
      arg_contact,
      arg_state);
}

static inline void
sip_svc_channel_interface_call_state_base_init_once (gpointer klass)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Interface.CallState");
  tp_svc_interface_set_dbus_properties_info (SIP_TYPE_SVC_CHANNEL_INTERFACE_CALL_STATE, &interface);

  channel_interface_call_state_signals[SIGNAL_CHANNEL_INTERFACE_CALL_STATE_CallStateChanged] =
  g_signal_new ("call-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _sip_ext_marshal_VOID__UINT_UINT,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (sip_svc_channel_interface_call_state_get_type (),
      &_sip_svc_channel_interface_call_state_object_info);
}
static void
sip_svc_channel_interface_call_state_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      sip_svc_channel_interface_call_state_base_init_once (klass);
    }
}
static const DBusGMethodInfo _sip_svc_channel_interface_call_state_methods[] = {
  { (GCallback) sip_svc_channel_interface_call_state_get_call_states, g_cclosure_marshal_VOID__POINTER, 0 },
};

static const DBusGObjectInfo _sip_svc_channel_interface_call_state_object_info = {
  0,
  _sip_svc_channel_interface_call_state_methods,
  1,
"org.freedesktop.Telepathy.Channel.Interface.CallState\0GetCallStates\0A\0States\0O\0F\0N\0a{uu}\0\0\0",
"org.freedesktop.Telepathy.Channel.Interface.CallState\0CallStateChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _sip_svc_channel_interface_hold_object_info;

struct _SIPSvcChannelInterfaceHoldClass {
    GTypeInterface parent_class;
    sip_svc_channel_interface_hold_get_hold_state_impl get_hold_state;
    sip_svc_channel_interface_hold_request_hold_impl request_hold;
};

enum {
    SIGNAL_CHANNEL_INTERFACE_HOLD_HoldStateChanged,
    N_CHANNEL_INTERFACE_HOLD_SIGNALS
};
static guint channel_interface_hold_signals[N_CHANNEL_INTERFACE_HOLD_SIGNALS] = {0};

static void sip_svc_channel_interface_hold_base_init (gpointer klass);

GType
sip_svc_channel_interface_hold_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SIPSvcChannelInterfaceHoldClass),
        sip_svc_channel_interface_hold_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SIPSvcChannelInterfaceHold", &info, 0);
    }

  return type;
}

/**
 * sip_svc_channel_interface_hold_get_hold_state_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetHoldState on interface org.freedesktop.Telepathy.Channel.Interface.Hold.
 */
static void
sip_svc_channel_interface_hold_get_hold_state (SIPSvcChannelInterfaceHold *self,
    DBusGMethodInvocation *context)
{
  sip_svc_channel_interface_hold_get_hold_state_impl impl = (SIP_SVC_CHANNEL_INTERFACE_HOLD_GET_CLASS (self)->get_hold_state);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * sip_svc_channel_interface_hold_implement_get_hold_state:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetHoldState D-Bus method
 *
 * Register an implementation for the GetHoldState method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
sip_svc_channel_interface_hold_implement_get_hold_state (SIPSvcChannelInterfaceHoldClass *klass, sip_svc_channel_interface_hold_get_hold_state_impl impl)
{
  klass->get_hold_state = impl;
}

/**
 * sip_svc_channel_interface_hold_request_hold_impl:
 * @self: The object implementing this interface
 * @in_hold: gboolean  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RequestHold on interface org.freedesktop.Telepathy.Channel.Interface.Hold.
 */
static void
sip_svc_channel_interface_hold_request_hold (SIPSvcChannelInterfaceHold *self,
    gboolean in_hold,
    DBusGMethodInvocation *context)
{
  sip_svc_channel_interface_hold_request_hold_impl impl = (SIP_SVC_CHANNEL_INTERFACE_HOLD_GET_CLASS (self)->request_hold);

  if (impl != NULL)
    {
      (impl) (self,
        in_hold,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * sip_svc_channel_interface_hold_implement_request_hold:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestHold D-Bus method
 *
 * Register an implementation for the RequestHold method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
sip_svc_channel_interface_hold_implement_request_hold (SIPSvcChannelInterfaceHoldClass *klass, sip_svc_channel_interface_hold_request_hold_impl impl)
{
  klass->request_hold = impl;
}

/**
 * sip_svc_channel_interface_hold_emit_hold_state_changed:
 * @instance: The object implementing this interface
 * @arg_state: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * HoldStateChanged signal on interface org.freedesktop.Telepathy.Channel.Interface.Hold.
 */
void
sip_svc_channel_interface_hold_emit_hold_state_changed (gpointer instance,
    guint arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD));
  g_signal_emit (instance,
      channel_interface_hold_signals[SIGNAL_CHANNEL_INTERFACE_HOLD_HoldStateChanged],
      0,
      arg_state);
}

static inline void
sip_svc_channel_interface_hold_base_init_once (gpointer klass)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Interface.Hold");
  tp_svc_interface_set_dbus_properties_info (SIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD, &interface);

  channel_interface_hold_signals[SIGNAL_CHANNEL_INTERFACE_HOLD_HoldStateChanged] =
  g_signal_new ("hold-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (sip_svc_channel_interface_hold_get_type (),
      &_sip_svc_channel_interface_hold_object_info);
}
static void
sip_svc_channel_interface_hold_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      sip_svc_channel_interface_hold_base_init_once (klass);
    }
}
static const DBusGMethodInfo _sip_svc_channel_interface_hold_methods[] = {
  { (GCallback) sip_svc_channel_interface_hold_get_hold_state, g_cclosure_marshal_VOID__POINTER, 0 },
  { (GCallback) sip_svc_channel_interface_hold_request_hold, _sip_ext_marshal_VOID__BOOLEAN_POINTER, 78 },
};

static const DBusGObjectInfo _sip_svc_channel_interface_hold_object_info = {
  0,
  _sip_svc_channel_interface_hold_methods,
  2,
"org.freedesktop.Telepathy.Channel.Interface.Hold\0GetHoldState\0A\0arg0\0O\0F\0N\0u\0\0org.freedesktop.Telepathy.Channel.Interface.Hold\0RequestHold\0A\0hold\0I\0b\0\0\0",
"org.freedesktop.Telepathy.Channel.Interface.Hold\0HoldStateChanged\0\0",
"\0\0",
};


