#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * SIPSvcChannelInterfaceCallState:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SIPSvcChannelInterfaceCallState SIPSvcChannelInterfaceCallState;

/**
 * SIPSvcChannelInterfaceCallStateClass:
 *
 * The class of SIPSvcChannelInterfaceCallState.
 */
typedef struct _SIPSvcChannelInterfaceCallStateClass SIPSvcChannelInterfaceCallStateClass;

GType sip_svc_channel_interface_call_state_get_type (void);
#define SIP_TYPE_SVC_CHANNEL_INTERFACE_CALL_STATE \
  (sip_svc_channel_interface_call_state_get_type ())
#define SIP_SVC_CHANNEL_INTERFACE_CALL_STATE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SIP_TYPE_SVC_CHANNEL_INTERFACE_CALL_STATE, SIPSvcChannelInterfaceCallState))
#define SIP_IS_SVC_CHANNEL_INTERFACE_CALL_STATE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SIP_TYPE_SVC_CHANNEL_INTERFACE_CALL_STATE))
#define SIP_SVC_CHANNEL_INTERFACE_CALL_STATE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SIP_TYPE_SVC_CHANNEL_INTERFACE_CALL_STATE, SIPSvcChannelInterfaceCallStateClass))


typedef void (*sip_svc_channel_interface_call_state_get_call_states_impl) (SIPSvcChannelInterfaceCallState *self,
    DBusGMethodInvocation *context);
void sip_svc_channel_interface_call_state_implement_get_call_states (SIPSvcChannelInterfaceCallStateClass *klass, sip_svc_channel_interface_call_state_get_call_states_impl impl);
/**
 * sip_svc_channel_interface_call_state_return_from_get_call_states:
 * @context: The D-Bus method invocation context
 * @out_States: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sip_svc_channel_interface_call_state_return_from_get_call_states (DBusGMethodInvocation *context,
    GHashTable *out_States);
static inline void
sip_svc_channel_interface_call_state_return_from_get_call_states (DBusGMethodInvocation *context,
    GHashTable *out_States)
{
  dbus_g_method_return (context,
      out_States);
}

void sip_svc_channel_interface_call_state_emit_call_state_changed (gpointer instance,
    guint arg_contact,
    guint arg_state);

/**
 * SIPSvcChannelInterfaceHold:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SIPSvcChannelInterfaceHold SIPSvcChannelInterfaceHold;

/**
 * SIPSvcChannelInterfaceHoldClass:
 *
 * The class of SIPSvcChannelInterfaceHold.
 */
typedef struct _SIPSvcChannelInterfaceHoldClass SIPSvcChannelInterfaceHoldClass;

GType sip_svc_channel_interface_hold_get_type (void);
#define SIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD \
  (sip_svc_channel_interface_hold_get_type ())
#define SIP_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD, SIPSvcChannelInterfaceHold))
#define SIP_IS_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD))
#define SIP_SVC_CHANNEL_INTERFACE_HOLD_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD, SIPSvcChannelInterfaceHoldClass))


typedef void (*sip_svc_channel_interface_hold_get_hold_state_impl) (SIPSvcChannelInterfaceHold *self,
    DBusGMethodInvocation *context);
void sip_svc_channel_interface_hold_implement_get_hold_state (SIPSvcChannelInterfaceHoldClass *klass, sip_svc_channel_interface_hold_get_hold_state_impl impl);
/**
 * sip_svc_channel_interface_hold_return_from_get_hold_state:
 * @context: The D-Bus method invocation context
 * @out0: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sip_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *context,
    guint out0);
static inline void
sip_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *context,
    guint out0)
{
  dbus_g_method_return (context,
      out0);
}

typedef void (*sip_svc_channel_interface_hold_request_hold_impl) (SIPSvcChannelInterfaceHold *self,
    gboolean in_hold,
    DBusGMethodInvocation *context);
void sip_svc_channel_interface_hold_implement_request_hold (SIPSvcChannelInterfaceHoldClass *klass, sip_svc_channel_interface_hold_request_hold_impl impl);
/**
 * sip_svc_channel_interface_hold_return_from_request_hold:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sip_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *context);
static inline void
sip_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void sip_svc_channel_interface_hold_emit_hold_state_changed (gpointer instance,
    guint arg_state);


G_END_DECLS
